#include<iostream>
#include<cstdio>
#include<vector>
#include<algorithm>
#define MAXN 1024
using namespace std;

int N, M;
int father[MAXN];
int A[MAXN][MAXN];

struct MSP{
    int a, b;
    int dis, un;
};

vector <MSP> vec;

void Union (int a, int b){
    father[a] = b;
}

int Find (int a){
    if (father[a] == -1) return a;
    int root = Find (father[a]);
    father[a] = root;
    return root;
}

bool fun (MSP i, MSP j){
    if (i.dis < j.dis) return 1;
    return 0;
}

int main (){
    freopen("graph.in","r",stdin);
    freopen("graph.out","w",stdout);

    scanf ("%d %d",&N, &M);

    for (int i=0; i<=N; i++)
        father[i] = -1;

    MSP helper;
    int a, b, c;
    for (int i=1; i<=M; i++){
        scanf ("%d %d %d",&a, &b, &c);
        helper.a = a;
        helper.b = b;
        helper.dis = c;
        helper.un = i;

        vec.push_back (helper);
    }
/*
    int a;
    for (int i=0; i<N; i++)
        for (int j=0; j<N; j++){
            scanf ("%d",&a);
            for (int t=0; t<M; t++)
        }
*/
    sort (vec.begin (), vec.end (), fun);

    for (int i=0; i<M; i++){
        int v1 = Find (vec[i].a);
        int v2 = Find (vec[i].b);

        if (v1 == v2)  continue;
        else{
            Union (v1, v2);
            printf ("%d\n",vec[i].un);
        }
    }
    return 0;
}
